<?php

declare(strict_types=1);

namespace FiloBlu\Refilo\Model;

use Magento\Catalog\Api\Data\ProductInterface;

/**
 * Class Upsell
 * @package FiloBlu\Refilo\Model
 */
class Upsell extends \Magento\TargetRule\Block\Catalog\Product\ProductList\Upsell {

    /**
     * @var ProductInterface|null
     */
    protected $currentProduct = null;

    /**
     * @return ProductInterface|\Magento\Catalog\Model\Product|null
     */
    public function getProduct() {
        return $this->currentProduct;
    }

    /**
     * @param ProductInterface $product
     * @return $this
     */
    public function setProduct(ProductInterface $product) {
        $this->currentProduct = $product;
        return $this;
    }

    /**
     * @return false
     */
    public function isShuffled() {
        return false;
    }

    /**
     * @param $limit
     * @return \Magento\Catalog\Model\ResourceModel\Product\Link\Product\Collection|null
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function _getPreparedTargetLinkCollection($limit = null)
    {
        return parent::_getPreparedTargetLinkCollection(null)->setPositionOrder();
    }

    /**
     * @return int
     */
    public function getPositionLimit(){
        return 10000;
    }
}
